> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://virtuous.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://virtuous.ferndocs.com/_mcp/server.

# Query segments based on the specified query request model.

POST https://prod-api.raisedonors.com/api/Segment/query
Content-Type: application/json

Reference: https://virtuous.ferndocs.com/reference/raise/segment/querysegments

## Authentication

- `Authorization` header (required) — JWT Authorization header using the Bearer scheme. Example: "Authorization: Bearer \{token}"

## Request

### Body (application/json)

This endpoint expects a Segment_querysegments_Request.

- `Segment_querysegments_Request`
  - QueryRequestModel: QueryRequestModel
  - ParsedQueryResponseModel: ParsedQueryResponseModel

## Response

### 200

OK

- `items` (list of SegmentModel, optional)
- `total` (integer, optional)

## Errors

### 400 Bad Request Error

Bad Request

- `Segment_QuerySegmentsRequestBadRequestError`
  - ProblemDetails: ProblemDetails
  - HttpValidationProblemDetails: HttpValidationProblemDetails

## Types

### QueryRequestModel

Request body for advanced query endpoints such as donor and campaign queries.

- `filter` (string, optional, nullable)
- `skip` (integer, optional)
- `take` (integer, optional)
- `sortBy` (enum, optional, nullable) — Field to sort by (case-insensitive). Valid options: createdate, createddatetime, email, firstname, gifts, giftsum, id, lastname, modifieddatetimeutc, name, phone
  - Allowed values: `createdate`, `createddatetime`, `email`, `firstname`, `gifts`, `giftsum`, `id`, `lastname`, `modifieddatetimeutc`, `name`, `phone`
- `descending` (boolean, optional)
- `includeDetails` (boolean, optional)
- `queryType` (enum, optional) — The logical type of query being executed.
  - Allowed values: `0`, `1`, `2`, `3`, `4`, `5`, `6`, `7`, `8`, `9`
- `groups` (list of QueryGroupModel, optional, nullable) — The groups of conditions that make up the query.
- `selectedColumns` (list of string, optional, nullable) — The list of result columns to return for each item.
- `empty` (boolean, optional) — Indicates whether the query has any conditions defined.

### ParsedQueryResponseModel

Represents a parsedquery response model.

- `descending` (boolean, optional)
- `empty` (boolean, optional) — Indicates whether the query has any conditions defined.
- `filter` (string, optional, nullable)
- `groups` (list of QueryGroupModel, optional, nullable) — The groups of conditions that make up the query.
- `includeDetails` (boolean, optional)
- `queryType` (enum, optional) — The logical type of query being executed.
  - Allowed values: `0`, `1`, `2`, `3`, `4`, `5`, `6`, `7`, `8`, `9`
- `selectedColumns` (list of string, optional, nullable) — The list of result columns to return for each item.
- `skip` (integer, optional)
- `sortBy` (enum, optional, nullable) — Field to sort by (case-insensitive). Valid options: createdate, createddatetime, email, firstname, gifts, giftsum, id, lastname, modifieddatetimeutc, name, phone
  - Allowed values: `createdate`, `createddatetime`, `email`, `firstname`, `gifts`, `giftsum`, `id`, `lastname`, `modifieddatetimeutc`, `name`, `phone`
- `take` (integer, optional)

### SegmentModel

Represents a segment model.

- `id` (long, optional) — Gets or sets the identifier.
- `campaignId` (long, optional) — Gets or sets the campaign identifier.
- `campaignName` (string, optional, nullable) — Gets or sets the campaign name.
- `name` (string, optional, nullable) — Gets or sets the name.
- `description` (string, optional, nullable) — Gets or sets the description.
- `code` (string, optional, nullable) — Gets or sets the code.
- `externalIdentifier` (string, optional, nullable) — Gets or sets the external identifier.
- `totalDonors` (integer, optional) — Gets or sets the total donors.
- `totalGifts` (integer, optional) — Gets or sets the total gifts.
- `totalGiftAmount` (string, optional, nullable) — Gets or sets the total gift amount.
- `averageGiftAmount` (string, optional, nullable) — Gets or sets the average gift amount.
- `medianGiftAmount` (string, optional, nullable) — Gets or sets the median gift amount.
- `highestGiftAmount` (string, optional, nullable) — Gets or sets the highest gift amount.
- `totalVisitors` (integer, optional) — Gets or sets the total visitors.
- `conversionRate` (string, optional, nullable) — Gets or sets the conversion rate.
- `createdDateTime` (string, optional, nullable) — Gets or sets the created date time.
- `modifiedDateTime` (string, optional, nullable) — Gets or sets the modified date time.

### ProblemDetails

- `type` (string, optional, nullable)
- `title` (string, optional, nullable)
- `status` (integer, optional, nullable)
- `detail` (string, optional, nullable)
- `instance` (string, optional, nullable)

### HttpValidationProblemDetails

- `detail` (string, optional, nullable)
- `errors` (map from string to list of string, optional, nullable)
- `instance` (string, optional, nullable)
- `status` (integer, optional, nullable)
- `title` (string, optional, nullable)
- `type` (string, optional, nullable)

### QueryGroupModel

- `conditions` (list of QueryConditionModel, optional, nullable) — Gets or sets the conditions.
- `conjunct` (enum, optional) — Gets or sets the operator.
  - Allowed values: `0`, `1`

### QueryConditionModel

- `parameter` (string, optional, nullable) — Gets or sets the parameter.
- `operator` (enum, optional) — Gets or sets the operator.
  - Allowed values: `0`, `1`, `2`, `3`, `4`, `5`, `6`, `7`, `8`, `9`, `10`, `11`, `12`, `13`, `14`, `15`, `16`, `17`, `18`, `19`, `20`, `21`, `22`, `23`, `24`, `25`, `26`, `27`, `28`, `29`
- `value` (string, optional, nullable) — Gets or sets the value.
- `secondaryValue` (string, optional, nullable) — Gets or sets the secondary value.
- `values` (list of string, optional, nullable) — Gets or sets the values.
- `conjunct` (enum, optional) — Gets or sets the operator.
  - Allowed values: `0`, `1`

## Examples

**Request**

```json
{}
```

**Response**

```json
{
  "items": [
    {
      "id": 101,
      "campaignId": 202,
      "campaignName": "Spring Fundraiser 2024",
      "name": "Loyal Donors Segment",
      "description": "Segment of donors who have contributed more than $500 in the last year.",
      "code": "LOYAL2024",
      "externalIdentifier": "SEG-LOYAL-2024",
      "totalDonors": 350,
      "totalGifts": 480,
      "totalGiftAmount": "125000.00",
      "averageGiftAmount": "260.42",
      "medianGiftAmount": "200.00",
      "highestGiftAmount": "5000.00",
      "totalVisitors": 1200,
      "conversionRate": "29.17%",
      "createdDateTime": "2023-11-01T09:15:00Z",
      "modifiedDateTime": "2024-04-20T16:45:00Z"
    }
  ],
  "total": 1
}
```

**SDK Code**

```python
import requests

url = "https://prod-api.raisedonors.com/api/Segment/query"

payload = {}
headers = {
    "Authorization": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://prod-api.raisedonors.com/api/Segment/query';
const options = {
  method: 'POST',
  headers: {Authorization: '<apiKey>', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://prod-api.raisedonors.com/api/Segment/query"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://prod-api.raisedonors.com/api/Segment/query")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://prod-api.raisedonors.com/api/Segment/query")
  .header("Authorization", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://prod-api.raisedonors.com/api/Segment/query', [
  'body' => '{}',
  'headers' => [
    'Authorization' => '<apiKey>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://prod-api.raisedonors.com/api/Segment/query");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://prod-api.raisedonors.com/api/Segment/query")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```